.\"	$NetBSD: mii.4,v 1.23 2006/10/26 10:54:52 wiz Exp $
.\"
.\" Copyright (c) 1998, 2002 The NetBSD Foundation, Inc.
.\" All rights reserved.
.\"
.\" This code is derived from software contributed to The NetBSD Foundation
.\" by Jason R. Thorpe of the Numerical Aerospace Simulation Facility,
.\" NASA Ames Research Center.
.\"
.\" Redistribution and use in source and binary forms, with or without
.\" modification, are permitted provided that the following conditions
.\" are met:
.\" 1. Redistributions of source code must retain the above copyright
.\"    notice, this list of conditions and the following disclaimer.
.\" 2. Redistributions in binary form must reproduce the above copyright
.\"    notice, this list of conditions and the following disclaimer in the
.\"    documentation and/or other materials provided with the distribution.
.\"
.\" THIS SOFTWARE IS PROVIDED BY THE NETBSD FOUNDATION, INC. AND CONTRIBUTORS
.\" ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED
.\" TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
.\" PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL THE FOUNDATION OR CONTRIBUTORS
.\" BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
.\" CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
.\" SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
.\" INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
.\" CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
.\" ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
.\" POSSIBILITY OF SUCH DAMAGE.
.\"
.Dd October 13, 2006
.Dt MII 4
.Os
.Sh NAME
.Nm mii
.Nd IEEE 802.3 Media Independent Interface network bus
.Sh SYNOPSIS
.Cd "acphy*    at mii? phy ?		# Altima AC101 10/100 PHY"
.Cd "amhphy*   at mii? phy ?		# AMD 79c901 PHY (10BASE-T part)"
.Cd "bmtphy*   at mii? phy ?		# Broadcom BCM5201/5202 PHYs"
.Cd "brgphy*   at mii? phy ?		# Broadcom BCM5400/5401 Gig-E PHYs"
.Cd "ciphy*    at mii? phy ?		# Cicada CS8201 Gig-E PHYs"
.Cd "dmphy*    at mii? phy ?		# Davicom DM9101 PHYs"
.Cd "exphy*    at mii? phy ?		# 3Com internal PHYs"
.Cd "gentbi*   at mii? phy ?		# Generic ten-bit 1000BASE-X PHYs"
.Cd "glxtphy*  at mii? phy ?		# Level One LXT-1000 Gig-E PHYs"
.Cd "gphyter*  at mii? phy ?		# NatSemi DP83861 Gig-E PHYs"
.Cd "icsphy*   at mii? phy ?		# Integrated Circuit Systems ICS1890 PHYs"
.Cd "ikphy*    at mii? phy ?		# Intel 82563 PHYs"
.Cd "inphy*    at mii? phy ?		# Intel 82555 PHYs"
.Cd "iophy*    at mii? phy ?		# Intel 82553 PHYs"
.Cd "lxtphy*   at mii? phy ?		# Level One LXT-970 PHYs"
.Cd "makphy*   at mii? phy ?		# Marvel 88E1000 Gig-E PHYs"
.Cd "nsphy*    at mii? phy ?		# NatSemi DP83840 PHYs"
.Cd "nsphyter* at mii? phy ?		# NatSemi DP83843/DP83815 PHYs"
.Cd "pnaphy*   at mii? phy ?		# Generic HomePNA PHYs"
.Cd "qsphy*    at mii? phy ?		# Quality Semiconductor QS6612 PHYs"
.Cd "rgephy*   at mii? phy ?		# Realtek 8169S/8110S internal PHYs"
.Cd "rlphy*    at mii? phy ?		# Realtek 8139/8201L PHYs"
.Cd "sqphy*    at mii? phy ?		# Seeq 80220/80221/80223/80225 PHYs"
.Cd "tlphy*    at mii? phy ?		# ThunderLAN internal PHYs"
.Cd "tqphy*    at mii? phy ?		# TSC Semiconductor 78Q2120 PHYs"
.Cd "ukphy*    at mii? phy ?		# Generic/unknown PHYs"
.Cd "urlphy*   at mii? phy ?		# Realtek RTL8150L internal PHYs"
.Pp
.Cd options MIIVERBOSE
.Sh DESCRIPTION
Media Independent Interface is an IEEE standard serial bus for
connecting MACs (network controllers) to PHYs (physical media
interfaces).  The
.Nm
layer allows network device drivers to share support code for
various PHY models, and allows unused support for PHYs which
are not present in a system to be removed from the kernel.
.Pp
Network device drivers which use the
.Nm
layer carry the
.Dq mii
autoconfiguration attribute.  This allows kernel configuration
files to simply specify PHYs as described above in the synopsis.
.Pp
The following is an example of the messages displayed when a network
interface with an attached PHY is detected by the kernel:
.Bd -literal -offset indent
epic0 at pci0 dev 12 function 0: SMC EPIC/100 Fast Ethernet
epic0: interrupting at kn20aa irq 4
epic0: SMC9432TX, Ethernet address 00:e0:29:07:17:c4
qsphy0 at epic0 phy 3: QS6612 10/100 media interface, rev. 1
qsphy0: 10baseT, 10baseT-FDX, 100baseTX, 100baseTX-FDX, auto
.Ed
.Pp
All PHY drivers display the media types supported by the PHY when it
is detected by the kernel.  These media types are valid media keywords
for use with the
.Xr ifconfig 8
program.
.Sh SEE ALSO
.Xr acphy 4 ,
.Xr amhphy 4 ,
.Xr bmtphy 4 ,
.Xr brgphy 4 ,
.Xr ciphy 4 ,
.Xr dmphy 4 ,
.Xr exphy 4 ,
.Xr gentbi 4 ,
.Xr glxtphy 4 ,
.Xr gphyter 4 ,
.Xr icsphy 4 ,
.Xr ifmedia 4 ,
.Xr ikphy 4 ,
.Xr inphy 4 ,
.Xr iophy 4 ,
.Xr lxtphy 4 ,
.Xr makphy 4 ,
.Xr nsphy 4 ,
.Xr nsphyter 4 ,
.Xr pnaphy 4 ,
.Xr qsphy 4 ,
.Xr rgephy 4 ,
.Xr rlphy 4 ,
.Xr sqphy 4 ,
.Xr tlphy 4 ,
.Xr tqphy 4 ,
.Xr ukphy 4 ,
.Xr urlphy 4 ,
.Xr ifconfig 8
.Pp
The OUI assignments list can be found at:
.D1 http://standards.ieee.org/regauth/oui/index.shtml
